<template>
    <v-simple-table>
        <template v-slot:default>
            <tbody>
            <tr v-for="teacher in fields" :key="teacher.id" class="fieldRow">
                <td class="fieldInfo" @click="goToLesson(teacher.id)">
                    <h3>{{ teacher.field_name }}</h3>
                    <div>
                        <span v-for="(teach, i) in teacher.teachers" :key="i">
                            {{ teach.first_name + " " + teach.name }}<span
                                v-if="i < teacher.teachers.length - 1">,</span>
                        </span>
                    </div>
                </td>
                <td class="action-field">
                    <v-icon>{{ teacher.icon }}</v-icon>
                </td>
                <td class="action">
                    <field-edit :is-add="false"
                                :currentFieldId="teacher.id"
                                @clicked="updateFields"
                                style="display: inline"/>
                    <field-delete :id="teacher.id" @deleted="updateFields"/>
                </td>
            </tr>
            </tbody>
        </template>
    </v-simple-table>
</template>

<script>
import FieldEdit from '@/components/FieldEdit.component';
import FieldDelete from "@/components/FieldDelete.component";
import Services from "@/services/api";
import { SET_STUDENT_GROUP, SET_TEACHERS_INFOS } from "@/store/mutations.type";

export default {
    name: 'TableEdit',
    components: { FieldDelete, FieldEdit },
    props: {
        fields: {
            default: []
        }
    },
    methods: {
        goToLesson(idLesson) {
            this.$router.push({ name: 'LessonReader', params: { id: idLesson } });
        },
        async updateFields() {
            this.$emit('update')
        }
    },
    async mounted() {
        this.$store.commit(SET_TEACHERS_INFOS, await Services.teachersGET());
        this.$store.commit(SET_STUDENT_GROUP, await Services.groupsGET());
    }
}
</script>
<style lang="css" scoped>
.fieldRow {
    display: flex;
    flex-direction: row;
}

.fieldInfo {
    flex: 1;
}

.fieldInfo:hover {
    cursor: pointer;
}

.action-field {
    display: flex;
}

.action {
    border-left: 1px solid #dddddd;
    width: 100px;
    display: flex;
    flex-direction: row;
    align-items: center;
}
</style>
